; ihavedesire.lsp
;
; Rs[^̖₢ɑ΂ĐHו̖O͂ĉB
;

(load "jpnslisp.lsp")

(defun second (x) (cadr x))

(defun index (key string)
    (let ((i 0)
	  (ln (length key))
	  (len (length string)) )
	(if (> ln len) -1
	    (loop
		(if (> (+ i ln) len) (return -1))
		(if (string-equal key (subseq string i (+ i ln))) (return i))
		(setq i (1+ i)) ) ) ) )

(setq *things* '(
	("݂" Hו 20)
	("~J" Hו 20)
	("i" Hו 30)
	("" Hו 30)
	("o^[" Hו 70)
	("J[" Hו 100)
	("CX" Hו 100)
	("" Hו 100)
	("͂" Hו 100)
	("" Hו 100)
	("" Hו 100)
	("[" Hו 70)
	("ACXN[" Hו 80)
	("\tgN[" Hו 90)
	("ci" Hו 60)
	("ʋl" Hו 120)
	("p" Hו 130)
	("g[Xg" Hו 130)
	("sU" Hו 120)
	("P`bv" Hו 30)
	("}l[Y" Hו 30)
	("ǂ" Hו 100)
	("" Hו 100)
	("" Hו 100)
	("\o" Hו 100)
	("߂" Hו 100)
	("" Hו 100)
	("" Hו 100)
	("}[K" Hו 120)
	("" Hו 130)
	("RbP" Hו 130)
	("Ƃ񂩂" Hו 300)
	("gJc" Hו 300)
	("؃Jc" Hו 300)
	("Ă" Hו 200)
	("Ă߂" Hו 200)
	("`[n" Hו 200)
	("u" Hו 200)
	("" Hו 80)
	("" Hו 50)
	("" Hו 50)
	("S" Hו 50)
	("oii" Hו 50)
	("" Hו 50)
	("C`S" Hו 50)
	("" Hו 50)
	("" Hו 50)
	("" Hו 120)
	("hg" Hו 120)
	("" Hו 120)
	("" Hו 120)
	("M[U" Hו 250)
	("v" Hו 130)
	("T_" Hו 50)
	("" Hו 50)
	("^X" Hו 50)
	("Lxc" Hו 50)
	("g}g" Hו 50)
	("ώ" Hו 90)
	("" Hו 90)
	("" Hו 90)
	("̂" Hו 50)
	("C" Hו 50)
	("V`[" Hו 150)
	("nV" Hו 150)
	("" Hו 80)
	("" Hו 80)
	("rteL" Hו 250)
	("" Hו 100)
	("XCJ" Hו 100)
	("Ȃ" Hו 90)
	("" Hו 90)
	("" Hו 80)
	("H" Hו 80)
	("" Hו 80)
	("AW" Hו 80)
	("܂" Hו 80)
	("}O" Hו 80)
	("`R[g" Hו 180)
	("Xe[L" Hו 300)
) )

(setq *weight* 0)

(defun main ()
    (princ "uɂ͗~܂vversion1.00 by rr") (terpri)
    (setq *start-time* (now))
    (setq *manpuku-time* *start-time*)
    (let ((user))
	(princ "Rs[^:HוB")(terpri)
	(loop
	    (setq user (read-line))
	    (analize user)
	)
    )
)

(defun analize (line)
    (let ((d *things*) (kind) (k))
	(princ "Rs[^:")
	(loop
	    (if (null d) (progn (msg1) (return)))
	    (setq k (index (caar d) line))
	    (cond
		((= k -1) t)
		(t (msg2 (car d)) (return)) )
	    (setq d (cdr d)) ) ) )

(defun msg1 () (princ "͂m܂B") (terpri))

(defun msg2 (h)
    (let ((m))
	(cond
	    ((and (eql (second h) 'Hו) (> *weight* 400) (now> (now+ '(0 . 60) *manpuku-time*) (setq m (now))))
	     (princ "͂ȂtłB") (terpri) )
	    ((and (eql (second h) 'Hו) (> *weight* 400))
	     (setq *manpuku-time* (now))
	     (setq *weight* (car (last h)))
	     (princ "Ȃ󂢂ė܂BylłB") (terpri) )
	    ((eql (second h) 'Hו)
	     (setq *weight* (+ *weight* (car (last h))))
	     (princ "ylłB") (terpri) )
	)
    )
)

(main)
